Lattice Grid Buy a licence

demo D115

Density

compact through spacious, with the row height following the token

density: 'comfortable'

Building…
Loading a live grid…

The configuration

<script>
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeAction from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/svelte.esm.min.js';

  const lattice = createLatticeAction({ createGrid });

  let grid;

  const config = {
    rowKey: 'id',
    selection: 'multiple',
    density: 'standard',   // 'compact' | 'standard' | 'comfortable' | 'spacious', or a number
    columns: [
      { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
      { field: 'team', title: 'Team', filter: { type: 'set' } },
      { field: 'owner', title: 'Owner', filter: { type: 'set' } },
      { field: 'tier', title: 'Tier', cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
      { field: 'state', title: 'State', cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'active', title: 'Active', type: 'boolean' },
      { field: 'deprecated', title: 'Deprecated', type: 'boolean' },
      { field: 'version', title: 'Version', layout: { width: 100 } },
    ],
    rows,  // 5,000 service records
    // onGrid hands over the live grid the moment it is created; keep it so the
    // controls can switch the spacing at runtime, on the one grid.
    onGrid: (g) => { grid = g; },
  };

  const setDensity = (value) => grid.set('density', value);
</script>

<svelte:head>
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">
</svelte:head>

<div style="display: flex; gap: 8px; margin-bottom: 8px">
  <button on:click={() => setDensity('compact')}>Compact</button>
  <button on:click={() => setDensity('standard')}>Standard</button>
  <button on:click={() => setDensity('comfortable')}>Comfortable</button>
  <button on:click={() => setDensity('spacious')}>Spacious</button>
</div>
<div use:lattice={config} style="height: 540px"></div>

Setting row density with a single token

Density is the control most JavaScript data grid users touch before anything else, because it decides how many rows fit on screen without a scrollbar. Lattice Grid exposes it as one setting, density: 'comfortable', with compact and spacious as the other named steps, rather than as CSS a team has to author and maintain against the grid’s own layout. Row height, cell padding and the size of icon-only controls all read from the same density token, so a change to it is consistent across every column type and renderer instead of a patchwork of overrides that drift out of sync after a redesign. A developer reaches for compact when a screen holds a trading blotter or an admin table that benefits from more rows per scroll, and for spacious when the audience is scanning rather than transacting, or when a touch target needs more room to hit reliably. Because the row height is derived rather than hard-coded, switching density at runtime does not require a rebuild of the grid’s DOM or a manual recalculation of scroll offsets: the grid recomputes row heights and keeps the current scroll position and selection intact. This keeps density compatible with theming and with saved views, so a user’s preferred setting persists the same way a colour theme does.

How do I change row height in Lattice Grid?

Set the density option to 'compact', 'comfortable' or 'spacious' when configuring the grid, or call the equivalent runtime method to switch it after the grid exists. Row height, cell padding and control sizing all follow the token, so there is no need to set an explicit pixel height unless a row’s content requires it.

Lattice Grid Buy a licence

demo D115

Density

compact through spacious, with the row height following the token

density: 'comfortable'

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">
<style>
  #controls { display: flex; gap: 8px; margin-bottom: 8px; }
  #grid > div { height: 540px; }
</style>
<div id="app"></div>

<script type="module">
  import * as Vue from 'https://esm.sh/vue@3';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/vue.esm.min.js';

  const LatticeGrid = createLatticeGrid({ vue: Vue, createGrid });

  Vue.createApp({
    components: { LatticeGrid },
    data() {
      return {
        config: {
          rowKey: 'id',
          selection: 'multiple',
          density: 'standard',   // 'compact' | 'standard' | 'comfortable' | 'spacious', or a number
          columns: [
            { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
            { field: 'team', title: 'Team', filter: { type: 'set' } },
            { field: 'owner', title: 'Owner', filter: { type: 'set' } },
            { field: 'tier', title: 'Tier', cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
            { field: 'state', title: 'State', cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
            { field: 'region', title: 'Region', filter: { type: 'set' } },
            { field: 'active', title: 'Active', type: 'boolean' },
            { field: 'deprecated', title: 'Deprecated', type: 'boolean' },
            { field: 'version', title: 'Version', layout: { width: 100 } },
          ],
          rows,  // 5,000 service records
        },
      };
    },
    methods: {
      // Switch the spacing at runtime, on the one live grid.
      setDensity(value) {
        this.$refs.grid.grid().set('density', value);
      },
    },
    template: `
      <div id="controls">
        <button @click="setDensity('compact')">Compact</button>
        <button @click="setDensity('standard')">Standard</button>
        <button @click="setDensity('comfortable')">Comfortable</button>
        <button @click="setDensity('spacious')">Spacious</button>
      </div>
      <div id="grid"><lattice-grid ref="grid" v-bind="config" /></div>
    `,
  }).mount('#app');
</script>

Setting row density with a single token

Density is the control most JavaScript data grid users touch before anything else, because it decides how many rows fit on screen without a scrollbar. Lattice Grid exposes it as one setting, density: 'comfortable', with compact and spacious as the other named steps, rather than as CSS a team has to author and maintain against the grid’s own layout. Row height, cell padding and the size of icon-only controls all read from the same density token, so a change to it is consistent across every column type and renderer instead of a patchwork of overrides that drift out of sync after a redesign. A developer reaches for compact when a screen holds a trading blotter or an admin table that benefits from more rows per scroll, and for spacious when the audience is scanning rather than transacting, or when a touch target needs more room to hit reliably. Because the row height is derived rather than hard-coded, switching density at runtime does not require a rebuild of the grid’s DOM or a manual recalculation of scroll offsets: the grid recomputes row heights and keeps the current scroll position and selection intact. This keeps density compatible with theming and with saved views, so a user’s preferred setting persists the same way a colour theme does.

How do I change row height in Lattice Grid?

Set the density option to 'compact', 'comfortable' or 'spacious' when configuring the grid, or call the equivalent runtime method to switch it after the grid exists. Row height, cell padding and control sizing all follow the token, so there is no need to set an explicit pixel height unless a row’s content requires it.

Lattice Grid Buy a licence

demo D115

Density

compact through spacious, with the row height following the token

density: 'comfortable'

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
  { field: 'team', title: 'Team', filter: { type: 'set' } },
  { field: 'owner', title: 'Owner', filter: { type: 'set' } },
  { field: 'tier', title: 'Tier', cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
  { field: 'state', title: 'State', cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'active', title: 'Active', type: 'boolean' },
  { field: 'deprecated', title: 'Deprecated', type: 'boolean' },
  { field: 'version', title: 'Version', layout: { width: 100 } },
];

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div style="display:flex;gap:.5rem;margin-bottom:8px">' +
    '  <button (click)="set(\'compact\')">Compact</button>' +
    '  <button (click)="set(\'standard\')">Standard</button>' +
    '  <button (click)="set(\'comfortable\')">Comfortable</button>' +
    '  <button (click)="set(\'spacious\')">Spacious</button>' +
    '</div>' +
    '<lattice-grid [config]="grid" style="display:block;height:540px"></lattice-grid>',
})
export class AppComponent {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  grid = {
    rowKey: 'id',
    selection: 'multiple',
    density: 'standard',
    columns,
    rows: [/* 5,000 service records */],
  };

  // Switch the spacing at runtime, on the one grid, through the live instance.
  set(d: string) { this.gridRef.grid.set('density', d); }
}

bootstrapApplication(AppComponent);

Setting row density with a single token

Density is the control most JavaScript data grid users touch before anything else, because it decides how many rows fit on screen without a scrollbar. Lattice Grid exposes it as one setting, density: 'comfortable', with compact and spacious as the other named steps, rather than as CSS a team has to author and maintain against the grid’s own layout. Row height, cell padding and the size of icon-only controls all read from the same density token, so a change to it is consistent across every column type and renderer instead of a patchwork of overrides that drift out of sync after a redesign. A developer reaches for compact when a screen holds a trading blotter or an admin table that benefits from more rows per scroll, and for spacious when the audience is scanning rather than transacting, or when a touch target needs more room to hit reliably. Because the row height is derived rather than hard-coded, switching density at runtime does not require a rebuild of the grid’s DOM or a manual recalculation of scroll offsets: the grid recomputes row heights and keeps the current scroll position and selection intact. This keeps density compatible with theming and with saved views, so a user’s preferred setting persists the same way a colour theme does.

How do I change row height in Lattice Grid?

Set the density option to 'compact', 'comfortable' or 'spacious' when configuring the grid, or call the equivalent runtime method to switch it after the grid exists. Row height, cell padding and control sizing all follow the token, so there is no need to set an explicit pixel height unless a row’s content requires it.

Lattice Grid Buy a licence

demo D115

Density

compact through spacious, with the row height following the token

density: 'comfortable'

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'service', title: 'Service', layout: { pin: 'start', width: 140 } },
    { field: 'team', title: 'Team', filter: { type: 'set' } },
    { field: 'owner', title: 'Owner', filter: { type: 'set' } },
    { field: 'tier', title: 'Tier', cell: { decoration: 'pill', variant: { map: { gold: 'warning', silver: 'neutral', bronze: 'info' } } } },
    { field: 'state', title: 'State', cell: { decoration: 'dot', variant: { map: { healthy: 'success', degraded: 'warning', failing: 'danger', unknown: 'neutral' } } } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'active', title: 'Active', type: 'boolean' },
    { field: 'deprecated', title: 'Deprecated', type: 'boolean' },
    { field: 'version', title: 'Version', layout: { width: 100 } },
  ];

  const rows = [/* 5,000 service records */];

  function App() {
    const gridRef = React.useRef(null);
    // Switch the spacing at runtime, on the one grid, through the live instance.
    const set = (d) => gridRef.current.grid.set('density', d);

    return (
      <>
        <div style={{ display: 'flex', gap: '.5rem', marginBottom: '8px' }}>
          <button onClick={() => set('compact')}>Compact</button>
          <button onClick={() => set('standard')}>Standard</button>
          <button onClick={() => set('comfortable')}>Comfortable</button>
          <button onClick={() => set('spacious')}>Spacious</button>
        </div>
        <LatticeGrid
          ref={gridRef}
          rowKey="id"
          selection="multiple"
          density="standard"
          columns={columns}
          rows={rows}
          style={{ height: '540px' }}
        />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Setting row density with a single token

Density is the control most JavaScript data grid users touch before anything else, because it decides how many rows fit on screen without a scrollbar. Lattice Grid exposes it as one setting, density: 'comfortable', with compact and spacious as the other named steps, rather than as CSS a team has to author and maintain against the grid’s own layout. Row height, cell padding and the size of icon-only controls all read from the same density token, so a change to it is consistent across every column type and renderer instead of a patchwork of overrides that drift out of sync after a redesign. A developer reaches for compact when a screen holds a trading blotter or an admin table that benefits from more rows per scroll, and for spacious when the audience is scanning rather than transacting, or when a touch target needs more room to hit reliably. Because the row height is derived rather than hard-coded, switching density at runtime does not require a rebuild of the grid’s DOM or a manual recalculation of scroll offsets: the grid recomputes row heights and keeps the current scroll position and selection intact. This keeps density compatible with theming and with saved views, so a user’s preferred setting persists the same way a colour theme does.

How do I change row height in Lattice Grid?

Set the density option to 'compact', 'comfortable' or 'spacious' when configuring the grid, or call the equivalent runtime method to switch it after the grid exists. Row height, cell padding and control sizing all follow the token, so there is no need to set an explicit pixel height unless a row’s content requires it.